unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  uTheoraLib_DLL, StdCtrls;

type
  TForm1 = class(TForm)
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bmp:TBitmap;
    stream:TMemoryStream;
    movie: Pointer;
    wave : Pointer;

    procedure info;
  end;

var
  Form1:TForm1;
  
implementation

//R[obN֐

function cb_read(datasource:Pointer; destptr:Pointer; offset:Integer; size:Integer):Integer; cdecl;
begin
  //Offset
  TmemoryStream(datasource).Position := offset;  //BYTEPʂł
  RESULT := TmemoryStream(datasource).Read(destptr^,size);
end;

function cb_size(datasource:Pointer):Integer; cdecl;
begin
  RESULT := TMemoryStream(datasource).Size;
end;

function cb_scanline(bmpsource:Pointer; y:Integer):Pointer; cdecl;
begin
  RESULT := TBitmap(bmpsource).ScanLine[y];
end;

procedure cb_resize(bmpsource:Pointer; w,h:Integer); cdecl;
var
  b : Tbitmap;
begin
  b := bmpsource;
  //t[Ă΂̂ŃTCYȂXLbvĂĂ
  //eNAKv͂܂
  if not((w=b.Width)and(h=b.Height))then
  begin
    b.Width := w;
    b.Height:= h;
  end;
end;
//gp
{
function cb_decode(bmpsource:Pointer; sender:Pointer; yuvbuf:PTheoralib_yuv_buffer; vrev:Integer):Integer; cdecl;
var
  b : Tbitmap;
  //info : Ptheoralib_theorainfo;
begin
  b := bmpsource;

  //senderMovieDecoderNX|C^ł
  //info := theoralib_m_info(sender);

  //EԒl
  //i0...ϊDLLɈς˂܂ / 1...DLL̕ϊ𖳌܂j
  //ʏ͏1ԂdlŖL܂B
  //ARgɓ̕Lꍇ̂ݗOIɏꍇȂǂ0/1gĂB
  RESULT := 1;
end;
}

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //TheoraLib DLL
  if not(theoralib_dll_create('theoralib.dll'))then
  begin
    ShowMessage('DLL̓ǂݍ݂Ɏs܂B');
    halt;
  end;

  //]ARGB32BitBitmap
  bmp := TBitmap.Create;
  bmp.HandleType := bmDIB;  //DIBSection
  bmp.PixelFormat:= pf32bit;//ARGB32Bit
  bmp.Width:=8;             //ĂƁ[
  bmp.Height:=8;

  //DataStream
  stream := TMemoryStream.Create;
  stream.LoadFromFile('sample01.ogv');

  //TheoraMovieDecoder
  movie := theoralib_m_create;        //擾NX̐
  theoralib_m_setvrevers(movie,1);    //TBitmapWindowsBitmapȂ̂ŏ㉺]ă_O
  //theoralib_m_setdecodemode(movie,0);
  theoralib_m_load(                   //ǂݍ
    movie,
    stream,cb_read,cb_size,           //f[^Xg[|C^ƃR[obN֐
    bmp,cb_scanline,cb_resize,        //rbg}bv|C^ƃR[obN֐
    nil                               //fR[hR[obN֐BgpȂ̂NULL
  );
  //TheoraWaveDecoder
  wave := theoralib_w_create;         //擾NX̐
  theoralib_w_load(
    wave,
    stream,cb_read,cb_size            //f[^AMovieDecoderƋL
  );

  //V[No[
  ScrollBar1.Max := theoralib_m_totalframe(movie);  //t[P

  info;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //TheoraMovieDecoder
  theoralib_m_free(movie);
  theoralib_w_free(wave);

  //datasource/bmpspurce
  bmp.Free;
  stream.Free;

  //theoralib
  theoralib_dll_free;
end;

procedure TForm1.info;
var
  ti : Ptheoralib_theorainfo;
  vi : Ptheoralib_vorbisinfo;
begin
  Memo1.Clear;

  if (theoralib_m_exists(movie)=1)then
  begin
    ti := theoralib_m_info(movie);
    Memo1.Lines.Add('--TheoraInfo--');
    Memo1.Lines.Add(format('TotalFrame %d',[theoralib_m_totalframe(movie)]));
    Memo1.Lines.Add(format('TotalTime %d',[theoralib_m_totaltime(movie)]));
    Memo1.Lines.Add(format('Size %d,%d',[ti.width,ti.height]));
    Memo1.Lines.Add(format('FrameSize %d,%d',[ti.frame_width,ti.frame_height]));
    Memo1.Lines.Add(format('Offset %d,%d',[ti.offset_x,ti.offset_y]));
    Memo1.Lines.Add(format('FPS %f',[ti.fps_numerator/ti.fps_denominator]));
    Memo1.Lines.Add(format('ColorSpace %d',[ti.colorspace]));
    Memo1.Lines.Add(format('PixelFormat %d',[ti.pixelformat]));
  end;
  if (theoralib_w_exists(wave)=1)then
  begin
    vi := theoralib_w_info(wave);
    Memo1.Lines.Add('--VorbisInfo--');
    Memo1.Lines.Add(format('TotalFrame %d',[theoralib_w_totalsample(wave)]));
    Memo1.Lines.Add(format('TotalTime %d',[theoralib_w_totaltime(wave)]));
    Memo1.Lines.Add(format('Rate %d',[vi.rate]));
    Memo1.Lines.Add(format('Channels %d',[vi.channels]));
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  theoralib_m_decodeframe(movie,ScrollBar1.Position);
  BitBlt(
    Form1.Canvas.Handle,
    0,0,800,600,
    bmp.canvas.handle,
    0,0,
    SRCCOPY
  );

  Label1.Caption := format('NowFrame.%d',[theoralib_m_nowframe(movie)]);
end;

end.
